
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>

#define UPROBEREQ 	1
#define UPROBEDATA	2
#define UPROBEREPORT	3

struct Uprobereq {
	int 	msgtype;
	int	sequence;
	struct 	sockaddr_in coord;
	struct 	sockaddr_in src;
	struct 	sockaddr_in dst;
	struct  timeval     starttime;
	struct  timeval     timeout;
	int	packetsize;
	int	noofpacket;
};

struct Uprobeheader {
	int 	msgtype;
	int	reqsequence;
	struct 	sockaddr_in coord;
	struct 	sockaddr_in src;
	struct 	sockaddr_in dst;
	struct  timeval     starttime;
	struct  timeval     timeout;
	int	packetseq;
	int	packetdatasize;
};

struct Uprobedata {
	struct Uprobeheader uphdr;
	char updata[1500];
};

struct Uprobereport {
	int 	msgtype;
	int	sequence;
	struct 	sockaddr_in coord;
	struct 	sockaddr_in src;
	struct 	sockaddr_in dst;
	struct  timeval     starttime;
	struct  timeval     timeout;
	int	packetsize;
	int	noofpacket;
	char    data[1024];
};

union Uprobemsg {
	struct Uprobereq upreq;
	struct Uprobedata updata;
	struct Uprobereport uprep;
};
